package com.example.gengmei_flutter_plugin

import android.Manifest
import android.app.Activity
import android.app.Application
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.util.Log
import com.example.gengmei_flutter_plugin.utils.addTo
import com.example.myimagepicker.repository.ImageRespository
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar
import io.reactivex.disposables.CompositeDisposable
import java.util.*
import kotlin.collections.ArrayList
import kotlin.collections.HashMap

class GengmeiFlutterPlugin : MethodCallHandler {

    val disposable = CompositeDisposable();

    companion object {
        const val IMAGE_PICKER = "scan_image_picker"
        const val CAMERA_PREMISSION = 10090
        lateinit var resign: Registrar;
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            if (registrar.activity() == null) {
                return
            }
            resign = registrar;
//            registrar.addRequestPermissionsResultListener { id, permissions, grantResults ->
//                if (grantResults.size > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
//                    //OKKK
//                } else {
//                    //WORng
//                }
//                true;
//            }
            val channel = MethodChannel(registrar.messenger(), "gengmei_flutter_plugin")
            channel.setMethodCallHandler(GengmeiFlutterPlugin())
        }
    }

    var running=false;

    override fun onMethodCall(call: MethodCall, result: Result) {
        if (call.method == IMAGE_PICKER) {
            if (running){
                return;
            }
            running=true;
            Log.e("lsy", "  IMAGE_PICKER!! ");
            ImageRespository.getInstance().scanPhoneImage(resign.context().applicationContext).subscribe(
                    {
                        result.success(it);
                        running=false;
                    }, {
                result.error(it.message, it.message, it);
            }).addTo(disposable);
        } else {
            result.notImplemented()
        }
    }
}
