#import "GengmeiFlutterPlugin.h"
#import <AssetsLibrary/AssetsLibrary.h>
#import <Photos/Photos.h>
#import "Image/AlbumItem.h"

@interface GengmeiFlutterPlugin ()
@property(nonatomic)FlutterResult  result;
@property(atomic)int needSize;
@property(atomic)NSMutableDictionary<NSString*,NSMutableArray<NSMutableDictionary<NSString*,NSObject*>*>*>* finalMap;
@end

@implementation GengmeiFlutterPlugin
NSMutableArray<AlbumItem *> *assetCollectionList;
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"gengmei_flutter_plugin"
            binaryMessenger:[registrar messenger]];
  GengmeiFlutterPlugin* instance = [[GengmeiFlutterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
    assetCollectionList = [NSMutableArray array];
    
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    self.result=result;
    
  if ([@"scan_image_picker" isEqualToString:call.method]) {
      dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
          self.needSize=0;
          if (self.finalMap==nil) {
              self.finalMap=[NSMutableDictionary dictionary];
          }
          [self.finalMap removeAllObjects];
          [assetCollectionList removeAllObjects];
          [self scanPhoneImage];
          [self copyImg];
      });
  } else {
    result(FlutterMethodNotImplemented);
  }
}

-(void)scanPhoneImage{
    PHFetchResult<PHAssetCollection *> *favoritesCollection = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeSmartAlbum subtype:PHAssetCollectionSubtypeSmartAlbumFavorites options:NO];
    // 获得相机胶卷
    PHFetchResult<PHAssetCollection *> *assetCollections = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeAlbum subtype:PHAssetCollectionSubtypeSmartAlbumUserLibrary options:NO];
    // 获得全部相片
    PHFetchResult<PHAssetCollection *> *cameraRolls = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeSmartAlbum subtype:PHAssetCollectionSubtypeSmartAlbumUserLibrary options:NO];
    
    for (PHAssetCollection *collection in cameraRolls) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        if (model.collectionNumber !=0) {
            [assetCollectionList addObject:model];
        }
    }
    
    for (PHAssetCollection *collection in favoritesCollection) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        if (model.collectionNumber !=0) {
            [assetCollectionList addObject:model];
        }
    }
    
    for (PHAssetCollection *collection in assetCollections) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        
        if (model.collectionNumber!=0) {
            [assetCollectionList addObject:model];
        }
    }
    for (AlbumItem* item in assetCollectionList) {
        self.needSize+=[item collectionNumber];
    }
}

-(void) copyImg{
    for (int j=0; j<assetCollectionList.count; j++) {
        AlbumItem * item=assetCollectionList[j];
        PHFetchResult<PHAsset *> * assetResult =[item assets];
        for (int i=0; i<[assetResult count]; i++) {
            __block int needSize=[assetResult count];
            __block NSString* docName=[item collectionTitle];
            
            PHAsset * assets=[assetResult objectAtIndex:i];
//            if (assets.mediaType != PHAssetMediaTypeVideo){
                [[PHImageManager defaultManager] requestImageForAsset:assets targetSize:PHImageManagerMaximumSize contentMode:PHImageContentModeDefault options:nil resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
                    //                NSLog(@"INITTT___))))00000  %d   %d  %@",i,[assetResult count],info);
                    NSLog(@"isSafe?? %d   %@  %d",i,docName,needSize);
                    NSURL * url = [info objectForKey:@"PHImageFileURLKey"];
                    NSData *data = [NSData dataWithContentsOfURL:url];
                    UIImage* image = [UIImage imageWithData:data];
                    NSString *guid = [[NSProcessInfo processInfo] globallyUniqueString];
                    NSString *tmpFile = [NSString stringWithFormat:@"image_picker_%@.JPG", guid];
                    NSString *cacheDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
                    //            NSString *tmpDirectory = NSTemporaryDirectory();
                    NSString *tmpPath = [cacheDirectory stringByAppendingPathComponent:tmpFile];
                    NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
                    if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
                        NSLog(@"result  %@",tmpPath);
                        [queryItemDict setObject:tmpPath forKey:@"path"];
                        NSMutableArray * arr=self.finalMap[docName];
                        if (arr==nil) {
                            self.finalMap[docName]=[NSMutableArray array];
                            [self.finalMap[docName] addObject:queryItemDict];
                        }else{
                            [self.finalMap[docName] addObject:queryItemDict];
                        }
                        NSLog(@"SIZEEE  %d %d ",[arr count],self.needSize);
                        if ([arr count]==self.needSize) {
                            NSLog(@"OKKKKKK");
                            dispatch_async(dispatch_get_main_queue(), ^{
                                self.result(self.finalMap);
                            });
                        }
                    } else {
                        NSLog(@"ERRORRRR  ");
                        self.needSize--;
                    }
                }];
//            }
        }
    }
}


- (NSMutableDictionary*)useToFetchCollection {
    NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
    PHFetchResult<PHAssetCollection *> * collectionResult = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeMoment subtype:PHAssetCollectionSubtypeSmartAlbumFavorites options:nil];
    
    if (collectionResult.count == 0) {
        return queryItemDict;
    }
    PHFetchOptions *option = [[PHFetchOptions alloc] init];
    //ascending 为YES时，按照照片的创建时间升序排列;为NO时，则降序排列
    option.sortDescriptors = @[[NSSortDescriptor sortDescriptorWithKey:@"creationDate" ascending:YES]];
    PHAssetCollection* item=[collectionResult objectAtIndex:1];
    
    
    [collectionResult enumerateObjectsWithOptions:option usingBlock:^(PHAssetCollection * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        NSLog(@"%@--%@--%@", obj.localIdentifier, obj.localizedTitle,obj);
        PHFetchResult<PHAsset *> * assetResult = [PHAsset fetchAssetsInAssetCollection:obj options:NO];
        NSLog(@"INITTT  %d",collectionResult.count);
        //HashMap<String, ArrayList<HashMap<String, Any>>>
        for (int i=0; i<[assetResult count]; i++) {
            PHAsset * assets=[assetResult objectAtIndex:i];
            NSArray* tempArray=[NSArray array];
            if (assets.mediaType != PHAssetMediaTypeVideo){
                
            }
            
        
            
            [[PHImageManager defaultManager] requestImageForAsset:assets targetSize:PHImageManagerMaximumSize contentMode:PHImageContentModeDefault options:nil resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
//                NSLog(@"INITTT___))))00000  %d   %d  %@",i,[assetResult count],info);
                NSURL * url = [info objectForKey:@"PHImageFileURLKey"];
                NSLog(@"INITTT___))))00000 %@",url);
                NSData *data = [NSData dataWithContentsOfURL:url];
                UIImage* image = [UIImage imageWithData:data];
//                CGSize size;
//                if(image)
//                {
//                    size = image.size;
//                }
//                NSLog(@"INFO  %d",size);
                NSString *guid = [[NSProcessInfo processInfo] globallyUniqueString];
                NSString *tmpFile = [NSString stringWithFormat:@"image_picker_%@.JPG", guid];
                //            NSString *tmpDirectory = NSHomeDirectory();
                NSString *tmpDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
                //            NSString *tmpDirectory = NSTemporaryDirectory();
                NSString *tmpPath = [tmpDirectory stringByAppendingPathComponent:tmpFile];
                if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
                    NSLog(@"result  %@",tmpPath);
                } else {
                    NSLog(@"ERRORRRR  ");
                }
                //            NSLog(@"YEEEEEEE %@",url);
            }];
        }
    }];
    return queryItemDict;
}

- (void) findAllFiles{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    //在这里获取应用程序Documents文件夹里的文件及文件夹列表
//    NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//            NSString *documentDir = [documentPaths objectAtIndex:0];
//    NSString *tmpDirectory = NSTemporaryDirectory();
//     NSString *tmpDirectory = NSHomeDirectory();
    
    NSString *tmpDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    NSError *error = nil;
     NSArray *fileList = [[NSArray alloc] init];
    //fileList便是包含有该文件夹下所有文件的文件名及文件夹名的数组
            fileList = [fileManager contentsOfDirectoryAtPath:tmpDirectory error:&error];
    
    
    NSMutableArray *dirArray = [[NSMutableArray alloc] init];

    //在上面那段程序中获得的fileList中列出文件夹名
            for (NSString *file in fileList) {
                        NSString *path = [tmpDirectory stringByAppendingPathComponent:file];
                        NSLog(@"patH!!!  %@",path);
                }
}

@end
